#####################################################################
# 
# ZTxnQueue.py - Zope Transactional Queue Utilities
#
# $Id: TQUtility.py,v 1.1 2003/11/19 18:38:32 kevin Exp $
#
# Copyright (C) 2003 Kevin Gill
#
# Derived from the Xron version 0.0.10
# Copyright (C) 2000 Loren Stafford
#  
# Xron is Derived from the ZScheduler product version 0.0.7 in
# accord with the terms of the ZScheduler's license.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License  
# along with this program; if not, write to the 
#     Free Software Foundation, Inc., 
#     59 Temple Place - Suite 330, 
#     Boston, MA  02111-1307, USA.
# 
#####################################################################

""" Zope Transactional Queue Utilities """

import ThreadLock
from DateTime import DateTime

_UniqueId_mutex = ThreadLock.allocate_lock()
def UniqueId(params=[0, None]):
    """Unique Id Maker - makes up to 256 ids and then gets the per
    milli-second time stamp. """
    _UniqueId_mutex.acquire()
    try:
        if not params[1] or params[0] >= 256:
            params[1] = long(DateTime().millis()) << 8
            params[0] = 0
        rv = params[1] | params[0]
        params[0]+=1
        return rv
    finally:
        _UniqueId_mutex.release()

